using UnityEngine;
using System.Collections;

public class FontWriter : MonoBehaviour {
	
	private enum Characters
	{
		_0,
		_1,
		_2,
		_3,
		_4,
		_5,
		_6,
		_7,
		_8,
		_9,
		PERCENTAGE,
		COUNT
	}
	
	private static Texture[] textures;
	private const string PATH = "Textures/";
	private const float spacing = 15.0f;
	private static Vector2 characterSize = new Vector2(spacing, spacing);
	
	public void Awake()
	{
		textures = new Texture[(int)Characters.COUNT]
		{
			(Texture)Resources.Load(PATH + "0"),
			(Texture)Resources.Load(PATH + "1"),
			(Texture)Resources.Load(PATH + "2"),
			(Texture)Resources.Load(PATH + "3"),
			(Texture)Resources.Load(PATH + "4"),
			(Texture)Resources.Load(PATH + "5"),
			(Texture)Resources.Load(PATH + "6"),
			(Texture)Resources.Load(PATH + "7"),
			(Texture)Resources.Load(PATH + "8"),
			(Texture)Resources.Load(PATH + "9"),
			(Texture)Resources.Load(PATH + "percentage")
		};	
	}
	
	public static void WriteString(Rect rect, string s)
	{
		bool skipDrawing = false;
		
		// rect for right align; have another similar line for left align
 		Rect characterRect = new Rect(rect.x + rect.width - s.Length*spacing, rect.y, characterSize.x, characterSize.y);
		
		for (int i=0; i<s.Length; ++i)
		{
			skipDrawing = false;
			int characterIndex = (int)Characters.PERCENTAGE;
			
			if ('0' <= s[i] && s[i] <= '9')
			{
				characterIndex = (s[i]-'0');
			}
			else if (s[i] == ' ')
			{
				skipDrawing = true;
			}
			else if (s[i] == '.')
			{
				skipDrawing = true;
			}
			
			if (!skipDrawing)
			{
				GUI.DrawTexture(characterRect, textures[characterIndex]);
			}
			
			characterRect.x += spacing;
		}
	}
}
