using UnityEngine;
using System.Collections;

public class PlayerCameraController : MonoBehaviour {
		
	private LevelObject player;
	
	// TUNING
	private const float CAMERA_DISTANCE = 0.4f;
	private const float CAMERA_HEIGHT = 0.3125f; //0.3 not enough, 0.4 too much, 0.35 too much, 0.325 too much
	private const float LOOK_OFFSET_Y = 0.3125f;
	private const float LOOK_OFFSET_FORWARD = 0.25f;
	
	public void Awake()
	{
		// get gameobjects
		player = (LevelObject)GameObject.Find("Player").GetComponent(typeof(LevelObject));
	}
	
	public void Update ()
	{		
		// determine camera position
		Vector3 cameraPosition = player.transform.position - player.transform.forward * CAMERA_DISTANCE;
		cameraPosition.y += CAMERA_HEIGHT;
		camera.transform.position = cameraPosition;
		
		// determine camera target
		Vector3 cameraTarget = player.transform.position + player.transform.forward * LOOK_OFFSET_FORWARD;
		cameraTarget.y += LOOK_OFFSET_Y;
		camera.transform.LookAt(cameraTarget);	
	}
}
